# ***** BEGIN LICENSE BLOCK *****
# Version: MPL 1.1/GPL 2.0/LGPL 2.1
#
# The contents of this file are subject to the Mozilla Public License Version
# 1.1 (the "License"); you may not use this file except in compliance with
# the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS" basis,
# WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
# for the specific language governing rights and limitations under the
# License.
#
# The Original Code is mozilla.org code
#
# The Initial Developer of the Original Code is
# Mozilla Foundation
# Portions created by the Initial Developer are Copyright (C) 2007
# the Initial Developer. All Rights Reserved.
#
# Contributor(s):
#   Alexander Surkov <surkov.alexander@gmail.com> (original author)
#
# Alternatively, the contents of this file may be used under the terms of
# either the GNU General Public License Version 2 or later (the "GPL"), or
# the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
# in which case the provisions of the GPL or the LGPL are applicable instead
# of those above. If you wish to allow use of your version of this file only
# under the terms of either the GPL or the LGPL, and not to allow others to
# use your version of this file under the terms of the MPL, indicate your
# decision by deleting the provisions above and replace them with the notice
# and other provisions required by the GPL or the LGPL. If you do not delete
# the provisions above, a recipient may use your version of this file under
# the terms of any one of the MPL, the GPL or the LGPL.
#
# ***** END LICENSE BLOCK *****

DEPTH     = ../../..
topsrcdir = @top_srcdir@
srcdir    = @srcdir@
VPATH     = @srcdir@

LIBRARY_NAME  = IA2Marshal
MODULE        = accessibility
GRE_MODULE    = 1
DEFFILE       = $(win_srcdir)/IA2Marshal.def

IA2DIR        = $(topsrcdir)/other-licenses/ia2

include $(DEPTH)/config/autoconf.mk

DEFINES       += -DREGISTER_PROXY_DLL -D_WIN32_WINNT=0x400

GARBAGE       += $(MIDL_GENERATED_FILES)

FORCE_SHARED_LIB = 1

SRCS_IN_OBJDIR   = 1

MIDL_INTERFACES = \
  Accessible2.idl \
  AccessibleAction.idl \
  AccessibleApplication.idl \
  AccessibleComponent.idl \
  AccessibleEditableText.idl \
  AccessibleHyperlink.idl \
  AccessibleHypertext.idl \
  AccessibleImage.idl \
  AccessibleRelation.idl \
  AccessibleTable.idl \
  AccessibleText.idl \
  AccessibleValue.idl \
  $(NULL)

MIDL_ENUMS = \
  AccessibleEventId.idl \
  AccessibleRole.idl \
  AccessibleStates.idl \
  IA2CommonTypes.idl \
  $(NULL)

EXPORTS = \
  $(MIDL_INTERFACES:%.idl=%.h) \
  $(MIDL_INTERFACES:%.idl=%_i.c) \
  $(MIDL_ENUMS:%.idl=%.h) \
  $(NULL)

CSRCS	= \
  dlldata.c \
  $(MIDL_INTERFACES:%.idl=%_p.c) \
  $(MIDL_INTERFACES:%.idl=%_i.c) \
  $(NULL)

MIDL_GENERATED_FILES = \
  dlldata.c \
  $(MIDL_INTERFACES:%.idl=%_p.c) \
  $(MIDL_INTERFACES:%.idl=%_i.c) \
  $(MIDL_INTERFACES:%.idl=%.h) \
  $(MIDL_ENUMS:%.idl=%.h) \
  $(NULL)

include $(topsrcdir)/config/rules.mk

OS_LIBS = \
  kernel32.lib \
  rpcndr.lib \
  rpcns4.lib \
  rpcrt4.lib \
  ole32.lib \
  oleaut32.lib \
  $(NULL)

$(MIDL_GENERATED_FILES): $(addprefix $(IA2DIR)/,$(MIDL_INTERFACES) $(MIDL_ENUMS))
	for idl in $^; do \
	  $(MIDL) $(MIDL_FLAGS) -app_config -I $(IA2DIR) -Oicf $$idl; \
	done

# This marshall dll is also registered in the installer
register::
	regsvr32 -s $(DIST)/bin/$(SHARED_LIBRARY)

